#ifndef _MACH_H_
#define _MACH_H_

#include "types.h"
typedef struct mach
{
	UInt32 (*io_read_byte) (UInt32 addr);
	UInt32 (*io_read_halfword) (UInt32 addr);
	UInt32 (*io_read_word) (UInt32  addr);
	void (*io_write_byte) (UInt32 addr, UInt32 v);
	void (*io_write_halfword) (UInt32 addr, UInt32 v);
	void (*io_write_word) (UInt32 addr, UInt32 v);
	void (*io_do_cycle) ();
	void (*clear_int) (UInt32 irq);
	void (*set_int) (UInt32 irq);
	void (*disable_int) ();
	void (*enable_int) ();
	void (*sti) (UInt32 dreg);
	void (*cli) (UInt32 dreg);
} mach_t;

#endif
